VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const m_Syntax As String = "Microsoft Visual C#"
Private Const m_Version As String = "3.01"

Private m_Expl_Const As Boolean
Private m_Insert_After_Option As Boolean
Private m_AutoFormat As Boolean
Private m_ShowParams As Boolean
Private m_Type As String
Public m_Charset As Long
Private m_StructType As String

Public Property Let Charset(mCharset)
    m_Charset = mCharset
End Property

Public Property Get VarRanges() As Boolean
    'VB supports Public/Private: set it to True
    VarRanges = True
End Property

Public Sub mPublic()
    m_Type = "public "
    m_StructType = m_Type
End Sub

Public Sub mNoRange()
    m_Type = ""
End Sub

Public Sub mPrivate()
    m_Type = "private "
    m_StructType = m_Type
End Sub

Public Property Get Version() As String
    Version = m_Version
End Property

Public Property Get Syntax() As String
    Syntax = m_Syntax
End Property

Public Function InitPlugIn() As Boolean
    'Return True if Init is successful
    InitPlugIn = True
End Function

Public Property Get ShowParams() As Boolean
    'Only needed for MASM
    ShowParams = False
End Property

Public Property Let ShowParams(m_Use_ShowParams As Boolean)
    m_ShowParams = m_Use_ShowParams
End Property

Public Property Get AutoFormat() As Boolean
    'Return True if the programming langauge
    'supports Declarations in more than one line
    AutoFormat = True
End Property

Public Property Let AutoFormat(m_Use_AutoFormat As Boolean)
    m_AutoFormat = m_Use_AutoFormat
End Property

Public Property Get ExplConst() As Boolean
    'Return True if the programming langauge
    'supports explicit declaration of
    'constants
    ExplConst = True
End Property

Public Property Let ExplConst(m_Use_Expl_Const As Boolean)
    m_Expl_Const = m_Use_Expl_Const
End Property

Public Property Get InsertAfterOption() As Boolean
    InsertAfterOption = True
End Property

Public Property Let InsertAfterOption(m_Use_Insert_After_Option As Boolean)
    m_Insert_After_Option = m_Use_Insert_After_Option
End Property

Public Function GetType(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim mBuffer() As String
    Dim mDataBuffer() As String
    Dim i As Long
    m_Data = Replace(m_Data, " Byte", " byte")
    m_Data = Replace(m_Data, " String", " string")
    m_Data = Replace(m_Data, " Double", " double")
    m_Data = Replace(Replace(m_Data, "As Long", "As Int32"), "As Integer", "As Int16")
    m_Data = Replace(m_Data, Chr$(9), "")
    mDataBuffer = Split(m_Data, vbNewLine)
    m_Data = ""
    For i = 0 To UBound(mDataBuffer)
        mBuffer = Split(mDataBuffer(i), " As ")
        m_Data = m_Data & Chr$(9) & m_StructType & Trim$(mBuffer(1)) & " " & mBuffer(0) & ";" & IIf(i <> UBound(mDataBuffer), vbNewLine, "")
    Next i
    m_Data = Replace(m_Data, Chr(9) & m_StructType & vbNewLine, vbNewLine)
    m_Data = "struct " & m_Name & "{" & vbNewLine & m_Data & vbNewLine & "}"
    m_Data = Replace(m_Data, Chr$(13) & " ", " ")
    m_Data = Replace(m_Data, "'", "//")
    GetType = Replace(m_Data, Chr$(13) & Chr$(13) & Chr$(10), vbNewLine)
End Function

Public Function GetEnum(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim mBuffer As String
    mBuffer = m_Type & "enum " & m_Name & " : " & IIf(InStr(m_Data, Chr$(34)) > 0, "string", "int") & " {" & vbNewLine & m_Data & vbNewLine & "}"
    mBuffer = Replace(mBuffer, vbNewLine, ", ")
    mBuffer = Replace(mBuffer, Chr$(9), "")
    mBuffer = Replace(mBuffer, "{, ", "{")
    mBuffer = Replace(mBuffer, ", }", "}")
    GetEnum = Replace(mBuffer, Chr$(13) & Chr$(13) & Chr$(10), vbNewLine)
End Function

Public Function GetConst(m_Name As String, m_Data As String) As String
    Dim m_Temp As String
    If InStr(m_Data, Chr(34)) > 0 Then m_Temp = "string " Else m_Temp = "int "
    GetConst = m_Type & "const " & m_Temp & m_Name & " = " & m_Data & ";"
End Function

Public Function GetSub(m_Name As String, ByVal m_Data As String) As String
    GetSub = GetDec(m_Name, m_Data)
End Function

Public Function GetFunc(m_Name As String, ByVal m_Data As String) As String
    GetFunc = GetDec(m_Name, m_Data)
End Function

Private Function GetDec(m_Name As String, ByVal m_Data As String) As String
    Dim mBuffer As String
    Dim mDllName As String
    Dim mFuncVar As String
    Dim mAlias As String
    Dim mAliasName As String
    Dim mBufferArr() As String
    Dim mDataBuffer() As String
    Dim i As Long
    m_Data = Right$(m_Data, Len(m_Data) - 1)
    mDllName = Left$(m_Data, InStr(m_Data, Chr$(34)) - 1)
    If InStr(mDllName, ".") < 1 Then mDllName = mDllName & ".dll"
    m_Data = Right$(m_Data, Len(m_Data) - InStr(m_Data, Chr$(34)) - 1)
    m_Data = Replace(m_Data, "~", "")
    m_Data = Replace(m_Data, "?", "")
    m_Data = Replace(m_Data, "&", " As Int32")
    m_Data = Replace(m_Data, "%", " As Int16")
    m_Data = Replace(m_Data, "As String", " As string")
    m_Data = Replace(m_Data, "As Byte", " As byte")
    m_Data = Replace(m_Data, "As Any", " As any")
    If Right$(m_Data, 1) <> ")" Then
        mFuncVar = Right$(m_Data, Len(m_Data) - InStrRev(m_Data, ")") - 4) & " "
        m_Data = Left$(m_Data, InStrRev(m_Data, ")"))
    Else
        mFuncVar = "void "
    End If
    If InStr(m_Data, "Alias") > 0 Then
        m_Data = Right$(m_Data, Len(m_Data) - 7)
        mAliasName = Left$(m_Data, InStr(m_Data, Chr$(34)) - 1)
        m_Data = Right$(m_Data, Len(m_Data) - InStr(m_Data, Chr$(34)))
    End If
    mAlias = ", EntryPoint=" & Chr$(34) & mAliasName & Chr$(34)
    If m_Charset = 1 Then mAlias = Replace(mAlias, "A" & Chr(34), "W" & Chr(34)) Else mAlias = Replace(mAlias, "W" & Chr(34), "A" & Chr(34))
    m_Data = Trim$(m_Data)
    m_Data = Mid$(m_Data, 2, Len(m_Data) - 2)
    mDataBuffer = Split(m_Data, ",")
    m_Data = ""
    For i = 0 To UBound(mDataBuffer)
        mBufferArr = Split(mDataBuffer(i), " As ")
        mBufferArr(1) = Trim$(mBufferArr(1))
        If Not mBufferArr(1) = "Int32" And Not mBufferArr(1) = "string" And Not mBufferArr(1) = "byte" And Not mBufferArr(1) = "any" Then mBufferArr(1) = "[MarshalAs(UnmanagedType.Struct)]" & " " & mBufferArr(1)
        m_Data = m_Data & mBufferArr(1) & " " & Trim$(mBufferArr(0)) & IIf(UBound(mDataBuffer) <> i, ", ", "")
    Next i
    m_Data = " (" & m_Data & ")"
    mBuffer = "[DllImport(" & Chr$(34) & mDllName & Chr$(34) & IIf(mAliasName <> "", mAlias, "") & ")]" & vbNewLine & _
        FormatDec("static extern " & mFuncVar & m_Name & m_Data) & ";"
    GetDec = mBuffer
End Function

Private Function FormatDec(strText As String) As String
    Dim z As Integer
    Dim lStr As String, rStr As String
    If Not InStr(LCase$(strText), "static") > 0 Then Exit Function
    If InStr(strText, "()") > 0 Or m_AutoFormat = False Then
        FormatDec = strText
        Exit Function
    End If
    z = InStr(strText, "(")
    lStr$ = Left$(strText, z)
    rStr$ = Right$(strText, Len(strText) - z)
    strText = lStr$ & " " & vbNewLine & Chr(9) & Space$(1) & rStr$
    FormatDec = Replace(strText, ",", "," & vbNewLine & Chr(9))
End Function

Public Function Preview() As String
    Dim strTemp As String
    If m_Expl_Const Then
        strTemp = "const int Test = 1;" & vbNewLine & vbNewLine
    Else
        strTemp = "const Test = 1;" & vbNewLine & vbNewLine
    End If
    If m_AutoFormat Then
        strTemp = strTemp & "[DllImport(" & Chr(34) & "MyDLL" & Chr(34) & ")]" & vbNewLine & "static extern Int32 Test (" & vbNewLine & Chr(9) & "string Param1," & vbNewLine & Chr(9) & "string Param2," & vbNewLine & Chr(9) & "string Param3," & vbNewLine & Chr(9) & "string Param4);"
    Else
        strTemp = strTemp & "[DllImport(" & Chr(34) & "MyDLL" & Chr(34) & ")]" & vbNewLine & "static extern Int32 Test (" & "string Param1, string Param2, string Param3, string Param4);"
    End If
    If m_Insert_After_Option Then
        strTemp = "Option Explicit" & vbNewLine & vbNewLine & strTemp
    End If
    Preview = strTemp
End Function
